QGIS Application - Bug report #2882
Python support broken for 64 bit systems
2010-07-12 06:37 AM - Volker Frohlich

Status: Closed

Priority: Low

Assignee: Borys Jurgiel

Category: Python plugins

Affected QGIS version: Regression?: No
Operating System: Unix Easy fix?: No
Pull Request or Patch supplied: Resolution: fixed
Crashes QGIS or corrupts data: Copied to github as #: 12942
Description

The patch for ticket #2618 introduced a static path to a library, that does not pay respect to 64 bit systems.

http://trac.osgeo.org/qgis/changeset/13884

History

#1 - 2010-07-12 06:43 AM - gjm -

Can you give more details please?

Commit commit:576c0409 (SVN r13885) was developed and tested on my 64-bit [[OpenSUSE]] 11.2 system.

#2 - 2010-07-12 06:49 AM - Volker Frohlich

Yes, the error message is:

Warning: Couldn't load Python support library: Cannot load library /usr/lib/ggispython: (/usr/lib/libggispython.so: cannot open shared object file: No such file

or directory)

The library is actually in /usr/lib64, not in /usr/lib.

#3 - 2010-07-12 07:39 AM - Jiirgen Fischer

Replying to [comment:2 volter]:

Yes, the error message is:

Warning: Couldn't load Python support library: Cannot load library /usr/lib/qgispython: (/usr/lib/libqgispython.so: cannot open shared object file: No
such file or directory)

The library is actually in /usr/lib64, not in /usr/lib.

The standard configuration wouldn't install into that directory - but QGIS_LIB_SUBDIR is configurable - so we should use the configured value. Does the
attached patch help (also for #2618)?
http://trac.osgeo.org/qgis/changeset/13884

#4 - 2010-07-12 07:56 AM - gjm -

Almost :) | think that the second attached patch will do it.

#5 - 2010-07-12 08:07 AM - gjm -

A question: should QGIS_LIB_SUBDIR be used for all systems, including the current two special cases in the code for Mac and Mgwin32?

That is, rather than the defines, should the code just be

pythonlibName.prepend( [[QgsApplication]]::prefixPath() + "/* + QGIS_LIB_SUBDIR + "/");

(with a suitable Qt function to get the right path separator?).

#6 - 2010-07-12 08:19 AM - Jiirgen Fischer

Replying to [comment:5 gjm]:

A question: should QGIS_LIB_SUBDIR be used for all systems, including the current two special cases in the code for Mac and Mgwin32?

Well, for OSX there is the xcode project, which is used to create the packages. |don't know if it has/uses QGIS_LIB_SUBDIR. | also never uses
[[MinGW]] to build QGIS. So IMHO better save than sorry ;)

(with a suitable Qt function to get the right path separator?).

| don't think we need to care about that. On Windows boths seperators work and IIRC in some circumstances Qt wouldn't work with backslashes.

#7 - 2010-07-12 08:21 AM - Volker Fréhlich

The second patch is working for me, didn't try the first one.

#8 - 2010-07-12 08:42 AM - William Kyngesburye

Replying to [comment:5 gjm]:

A question: should QGIS_LIB_SUBDIR be used for all systems, including the current two special cases in the code for Mac and Mgwin32?

QGIS_LIB_SUBDIR is used on the Mac build, in both cmake and xcode.

#9 - 2010-07-12 08:49 AM - gjm -

Replying to [comment:8 kyngchaos]:

Replying to [comment:5 gjm]:
A question: should QGIS_LIB_SUBDIR be used for all systems, including the current two special cases in the code for Mac and Mgwin32?

QGIS_LIB_SUBDIR is used on the Mac build, in both cmake and xcode.

But the code

#if defined(Q_WS_MAC)

pythonlibName.prepend( [[QgsApplication]]::prefixPath() + "/lib/" );

in ggisapp.cpp is hard-coding in /lib/ for the location of the qgis libraries, rather than using QGIS_LIB_SUBDIR (commit:5baeed1c (SVN r13913)).

#10 - 2010-07-12 08:54 AM - gjm -

The second attached patch has been applied (commit:5baeedic (SVN r13913)). The code for non-linux system remains unchanged (probably best to let

someone who compiles under Mac or Mingw32 to change them if necessary).

#11 - 2010-07-12 09:00 AM - William Kyngesburye
I meant that it is defined, and used, within the project/cmake files, so it is available to use in source files. Go ahead and group Mac and Linux in

qgisapp.cpp like in the original.

#12 - 2010-07-12 10:38 AM - gjm -
- Status changed from Open to Closed
- Resolution set to fixed

I'd rather wait until after version 1.5.0 has been branched (aka, if it's not broken, don't fix it immediately before a version is released:).

I'll add it to ticket #2863, which is where | have a few other non-urgent patches waiting for the branch.

#13 - 2010-07-18 05:07 AM - gjm -

Implement in

Files

diff 1010 Bytes 2010-07-12 Jurgen Fischer
patch.txt 1.03KB 2010-07-12 gjm -
